# How exposed are node.js projects to vulnerable packages?

To facilitate the reproduction and foment further research in the field, we provide a replication package containing the artifacts used to conduct our study approach to identify and classify npm vulnerable packages in a Github repo.


## Package Structure

To better understand the package and re-produce the data, we briefly describe the structure of our package:

- `repos_list.csv`: Contains links to the list of GitHub repos to be analyzed. In this file, we list a couple of repos for the matter of testing the pipeline run.

- `Step1`: Implements Step 1 in our approach (Section 4); which extracts the dependency list. The output of this step is the dependency list used in each project through the project lifetime.

- `Step2`: Implement Step 2 in our approach (Section 4), which identifies the vulnerable dependency versions.

- `Step3`:  Implements Step 3 in our approach (Section 4), which classifies each dependency vulnerability according to our defined discoverability levels.


## To run the package and analyze the projects listed in the file `repos_list.csv`:

- `Requirements`: install Python (version >= 3), install Git (version >= 2), install Node (version >= 8). The scripts will likely work out of the box on any Linux-like and Mac platforms upon providing the right requirements and versions.

- execute `analyze.py`: This script is a pipeline that calls all the three steps above.  

- The final output will be saved in `Step3/OUTPUT`. The output contains CSV files, one for each analyzed project. The CSV file contains the analysis of discoverability levels for the project and metadata related to the analyzed packages.

- For any further requests or help, please don't hesitate to contact the study authors!
