import csv
import os
import subprocess
import json
from time import sleep
import tqdm
"""

This script generates all the versions of the vulnerable packages in the advisories file

"""
class package_version_time:
  def __init__(self, package, version, time):
    self.package = package
    self.version = version
    self.time = time

def get_packages_release_time(all_advisories):
    file_path = "./"
    all_advisories_path = os.path.join(file_path, all_advisories)
    packages = []
    with open(all_advisories_path) as f:
        reader = csv.DictReader(f, delimiter=',')
        next(reader)
        for row in reader:
            package = row['module_name']
            #version = row['version']
            if not package in packages:
                packages.append(package)
                #print(package)
    
    print("done getting packages names from " + all_advisories)
    package_version_time_list = []
    for p in tqdm.tqdm(packages):
        # print at which package we arrive 
        #print("getting versions of package " + p)
        try:
            o = subprocess.check_output(['npm','view', p,'time', '--json'])
            json_object = json.loads(o)
            for package_version in json_object.items():
                #print(p, package_version[0], package_version[1])
                if package_version[0] == 'modified' or package_version[0] == 'created': 
                    continue
                package_version_time_list.append(package_version_time(p, package_version[0], package_version[1]))
        except:
            continue
        
        

    print("done getting versions of packages")
    print("writing to package_version_time.csv")
    output_file = "package_version_time.csv"
    output_file_path = os.path.join(file_path, output_file)
    with open(output_file_path, 'w') as f:
        writer = csv.writer(f, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
        writer.writerow(('package', 'version', 'time'))
        for p_v_t in package_version_time_list:
            #print(p_v_t.package)
            writer.writerow((p_v_t.package, p_v_t.version, p_v_t.time))
    print("--- done ---")
get_packages_release_time("all_advisories_v3.csv")
