"""
Collect vulnerable package Information
"""

import sys, os
try:
    import xlrd, xlsxwriter, selenium, pandas as pd
except ImportError:
    print('Error: Dependency/dependencies not installed!')
    os.system('pip3 install selenium pandas xlsxwriter xlrd')
    print('Please, re-run the script')
    sys.exit(0)
from selenium import webdriver
from webdriver_manager.chrome import ChromeDriverManager
from selenium.common.exceptions import TimeoutException
from selenium.webdriver.common.by import By
from selenium.webdriver.support import expected_conditions as EC
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support.ui import Select
import datetime, time, csv
import re, random
import traceback
from selenium.webdriver.support.ui import Select

chromeOptions = webdriver.ChromeOptions()
prefs = {
            "profile.managed_default_content_settings.images":2,
            "profile.default_content_setting_values.notifications" : 2,
            'disk-cache-size': 1024,
        }


# chromeOptions.add_argument('--proxy-server=http://%s' % PROXY)

chromeOptions.add_experimental_option("prefs",prefs)
chromeOptions.add_argument('headless')
driver = webdriver.Chrome(ChromeDriverManager().install())
##driver = webdriver.Chrome(options=chromeOptions)

driver.get("https://www.npmjs.com/advisories?page=0&perPage=1484")
advisories = []
for a in driver.find_elements_by_tag_name("a"):
    if "/advisories/" in a.get_attribute('href'):
        advisories.append(int(a.get_attribute('href').replace("https://www.npmjs.com/advisories", "").replace("/","")))
# print(advisories)

data = []
for i in advisories:
    try:
        chromeOptions = webdriver.ChromeOptions()
        prefs = {
                    "profile.managed_default_content_settings.images":2,
                    "profile.default_content_setting_values.notifications" : 2,
                    'disk-cache-size': 1024,
                }


        # chromeOptions.add_argument('--proxy-server=http://%s' % PROXY)

        chromeOptions.add_experimental_option("prefs",prefs)
        chromeOptions.add_argument('headless')
        driver = webdriver.Chrome(ChromeDriverManager().install())
        #driver = webdriver.Chrome(chrome_options=chromeOptions)

        link = "https://npmjs.com/advisories/%d"%i
        driver.get(link)
        published, reported = "", ""
        for p in driver.find_elements_by_css_selector("div.timeline__inner___2kmjY"):
            if "Published" in p.text:
                published = p.text
            elif "Reported" in p.text:
                reported = p.text
        # print(published, reported)
        package = driver.find_element_by_css_selector('a.card-head__moduleName___1rS-u')
        package_link = package.get_attribute('href')
        package = package.text
        severity = driver.find_element_by_css_selector('img.card-head__badge___24wxC').get_attribute('alt').replace('Severity: ', '')
        title = driver.find_element_by_css_selector("h1.card-head__title___2z8RS").text
        texts = [t.text for t in driver.find_elements_by_class_name('markdown__markdown___3yof6')]
        overview = texts[0]
        remediation = texts[1]
        resources = texts[-1]
        driver.get(link+"/versions")
        affected, unaffected = driver.find_elements_by_css_selector("dl.advisory-detail__versions___3QgX7")

        for dt, dd in zip(affected.find_elements_by_tag_name("dt"), affected.find_elements_by_tag_name("dd")):
            data.append({
                'id': i,
                'package': package,
                'type': title,
                'overview': overview,
                'remediation': remediation,
                'resources': resources,
                'version': dt.text,
                'time': dd.text,
                'status': 'affected',
                'severity': severity,
                'package link': package_link,
                'advisory link': link,
                })
        for dt, dd in zip(unaffected.find_elements_by_tag_name("dt"), unaffected.find_elements_by_tag_name("dd")):
            data.append({
                'id': i,
                'package': package,
                'type': title,
                'overview': overview,
                'remediation': remediation,
                'resources': resources,
                'version': dt.text,
                'time': dd.text,
                'status': 'unaffected',
                'severity': severity,
                'package link': package_link,
                'advisory link': link,
                'published': published,
                'reported': reported,
                })
    except Exception as e:
        print("failed: ", i)
        print(e)
        
    print(i)
    driver.close()
    driver.quit()
    time.sleep(45)

df = pd.DataFrame()

df = df.append(data, ignore_index=True)
df = df.drop_duplicates()
df.to_csv('advisories_from_scraper.csv', index=False)
